RaidSnacks = LibStub("AceAddon-3.0"):NewAddon("RaidSnacks", "AceConsole-3.0")
local L = LibStub("AceLocale-3.0"):GetLocale("RaidSnacks", true)
local AceConfig = LibStub("AceConfig-3.0")
local AceConfigDialog = LibStub("AceConfigDialog-3.0")
local AceConfigRegistry = LibStub("AceConfigRegistry-3.0")
local pairs, string, select, print, format = pairs, string, select, print, format
local GetMapNameByID, GetCurrentMapAreaID = GetMapNameByID, GetCurrentMapAreaID
local LoggingCombat = LoggingCombat
local pairs, string, select, print, format = pairs, string, select, print, format
local GetBindingKey, SetBinding, IsInInstance = GetBindingKey, SetBinding, IsInInstance
local GetRaidDifficultyID, IsInRaid, IsPartyLFG = GetRaidDifficultyID, IsInRaid, IsPartyLFG
local IsInLFGDungeon, GetDungeonDifficultyID = IsInLFGDungeon, GetDungeonDifficultyID
local UIFrameFade = UIFrameFade

function RaidSnacks:OnInitialize()
  -- Code that you want to run when the addon is first loaded goes here.
  RaidSnacks:Print(L["RaidSnacks r20150711095051"])
  		local defaults = {
		char = {
			enable = false,	
		    curLogging = false, 
		    dungeons = false, 
		    hidelk = nil, 
		    hidecat = false, 
		    hidemop = false, 
		    hidewod = false, 
		    osw = true,
			raids10 = nil, 
			raids25 = nil, 
			raids10h = nil, 
			raids25h = nil, 
			lfr = {}, 
			flex = nil, 
			mythic = {}, 
			normal = {}, 
			heroic = {}, 
			challenge = false,
			mythicdungeons = false,
		},
	}
	RaidSnacks.db = LibStub("AceDB-3.0"):New("RaidSnacks_DB", defaults)
end

function RaidSnacks:GetSetting(settingtype, raid) 
	return RaidSnacks.db.char[settingtype][raid] 
end

function RaidSnacks:SetSetting(settingtype, raid, settingvalue) 
	RaidSnacks.db.char[settingtype][raid] = settingvalue
end



-- -[Config Menu]--------------------------------------------------------------
--map IDs
local map_id_list = {
	["42BWD"] = 754, ["45BTW"] = 758, ["46TFW"] = 773, ["41BAH"] = 752, 
	["44FIR"] = 800, ["43DGS"] = 824, 
	["52MGS"] = 896, ["53TES"] = 886, ["51HOF"] = 897, ["54TOT"] = 930, 
	["55SOO"] = 953, 
	["61BRF"] = 988, ["62HGM"] = 994, ["63HFC"] = 1026,
}

local raid_normal = {"42BWD", "45BTW", "46TFW", "41BAH", "44FIR", "43DGS", "52MGS", "53TES", "51HOF", "54TOT", "55SOO", "61BRF", "62HGM", "63HFC"}
local raid_heroic = {"42BWD", "45BTW", "46TFW", "44FIR", "43DGS", "52MGS", "53TES", "51HOF", "54TOT", "55SOO", "61BRF", "62HGM", "63HFC"}
local raid_lfr = {"43DGS", "52MGS", "53TES", "51HOF", "54TOT", "55SOO", "61BRF", "62HGM", "63HFC"}
local raid_mythic = {"55SOO", "61BRF", "62HGM", "63HFC"}

local function MakeList(raids)
    local list = {}
    local colours = {["4"] = "ff778899", ["5"] = "ff6e8b3d", ["6"] = "ffffd700"}
    for _, r in pairs(raids) do 
    	local exp = string.sub(r,1,1)
        local c = colours[exp]
        list[r] = "|c" .. c .. GetMapNameByID(map_id_list[r])
    end
    return list
end


local options = {
    name = "RaidSnacks",
    handler = RaidSnacks,
    type = 'group',
    args = {
        raidsn = { -- Normal raids select
            type = "multiselect",
            name = L["Normal Raids"],
            desc = L["Raid instances where you want to log combat"],
            values = MakeList(raid_normal),
            tristate = false,
            get = function(info, raid) return RaidSnacks:GetSetting("normal", raid) end,
            set = function(info, raid, value) RaidSnacks:SetSetting("normal", raid, value) end,
            order = 14,
        },
        raidsh = { -- Heroic raids select
            type = "multiselect",
            name = L["Heroic Raids"],
            desc = L["Raid instances where you want to log combat"],
            values = MakeList(raid_heroic),
            tristate = false,
            get = function(info, raid) return RaidSnacks:GetSetting("heroic", raid) end,
            set = function(info, raid, value) RaidSnacks:SetSetting("heroic", raid, value) end,
            order = 15,
        },
        mythic = { -- Mythic raids select
            type = "multiselect",
            name = L["Mythic Raids"],
            desc = L["Raid instances where you want to log combat"],
            values = MakeList(raid_mythic),
            tristate = false,
            get = function(info, raid) return RaidSnacks:GetSetting("mythic", raid) end,
            set = function(info, raid, value) RaidSnacks:SetSetting("mythic", raid, value) end,
            order = 16,
        },
        lfr = { -- LFR raids select
            type = "multiselect",
            name = L["LFR Raids"],
            desc = L["Raid finder instances where you want to log combat"],
            values = MakeList(raid_lfr),
            tristate = false,
            get = function(info, raid) return RaidSnacks:GetSetting("lfr", raid) end,
            set = function(info, raid, value) RaidSnacks:SetSetting("lfr", raid, value) end,
            order = 17,
        },
    },
}

local AceConfig = LibStub("AceConfig-3.0")
AceConfig:RegisterOptionsTable("RaidSnacks", options)
LibStub("AceConfig-3.0"):RegisterOptionsTable("RaidSnacks", options, {"raidsnacks", "snacks"})
RaidSnacks.optionsFrame = LibStub("AceConfigDialog-3.0"):AddToBlizOptions("RaidSnacks", "RaidSnacks")